var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { CustomError } from 'ts-custom-error';
import { addHours } from 'date-fns';
import deepmerge from 'deepmerge';
var TroError = /** @class */ (function (_super) {
    __extends(TroError, _super);
    function TroError(message, s_object_name, attributes) {
        var _this = _super.call(this) || this;
        _this.message = message;
        _this.s_object_name = s_object_name;
        _this.attributes = attributes;
        return _this;
    }
    TroError.prototype.toObject = function () {
        return {
            name: this.name,
            message: this.message,
            s_object_name: this.s_object_name,
            attributes: this.attributes,
        };
    };
    return TroError;
}(CustomError));
export { TroError };
var _getKeys = function (obj) { return Object.keys(obj); };
var _models = {};
var _getRemoteObject = function (s_object_name) {
    return _models[s_object_name];
};
var _time_zone_offset;
var _remoting_path;
export var init = function (remoting_path, un_accessible_fields, time_zone_offset) {
    _time_zone_offset = time_zone_offset !== null && time_zone_offset !== void 0 ? time_zone_offset : 9;
    _remoting_path = remoting_path;
    _getKeys(un_accessible_fields).forEach(function (s_object_name) {
        var instance = new SObjectModel[s_object_name]();
        un_accessible_fields[s_object_name].forEach(function (_) { return delete instance._fields[_]; });
        _models[s_object_name] = instance;
    });
};
/**
 * @param where The 'Date' within the object undergoes destructive modification to become UTC time.
 * @returns When the `IN` clause is an empty array, it returns true.
 */
var _validateAndDateToUtc = function (where) {
    if (where == null) {
        return false;
    }
    return _getKeys(where).some(function (field_name) {
        if (field_name === 'and' || field_name === 'or') {
            return _validateAndDateToUtc(where[field_name]);
        }
        var operator = where[field_name];
        var operator_key = _getKeys(operator)[0];
        var value = operator[operator_key];
        if (value == null) {
            delete where[field_name];
            return false;
        }
        if (value instanceof Date) {
            operator[operator_key] = addHours(value, -_time_zone_offset);
            return false;
        }
        if (!Array.isArray(value)) {
            operator[operator_key] = value;
            return false;
        }
        if (operator_key === 'in' && value.length === 0) {
            return true;
        }
        operator[operator_key] = __spreadArray([], __read(new Set(value)), false).map(function (v) {
            return v instanceof Date ? addHours(v, -_time_zone_offset) : v;
        });
        return false;
    });
};
export var fetchAll = function (s_object_name_1) {
    var args_1 = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args_1[_i - 1] = arguments[_i];
    }
    return __awaiter(void 0, __spreadArray([s_object_name_1], __read(args_1), false), void 0, function (s_object_name, criteria) {
        var clone_criteria, is_no_result;
        if (criteria === void 0) { criteria = {}; }
        return __generator(this, function (_a) {
            clone_criteria = deepmerge({}, criteria);
            is_no_result = _validateAndDateToUtc(clone_criteria.where);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    if (is_no_result) {
                        setTimeout(function () { return resolve([]); });
                        return;
                    }
                    var field_infos = _getRemoteObject(s_object_name)._fields;
                    var field_names = Object.keys(field_infos);
                    try {
                        window.Visualforce.remoting.Manager.invokeAction(_remoting_path, s_object_name, field_names, JSON.stringify(clone_criteria), function (result, event) {
                            var _a;
                            if (event.status) {
                                //* D: Date
                                //* F: Datetime
                                //* f: Time
                                var date_or_datetime_field_names_1 = field_names.filter(function (_) { return ['D', 'F', 'f'].includes(field_infos[_].type); });
                                resolve(JSON.parse(result, function (key, value) {
                                    if (date_or_datetime_field_names_1.includes(key)) {
                                        var date = new Date(field_infos[key].type === 'f' ? "1970-01-01T".concat(value) : value);
                                        if (!isNaN(date.getTime())) {
                                            return date;
                                        }
                                    }
                                    return value;
                                }));
                                return;
                            }
                            var isJson = function (value) {
                                try {
                                    JSON.parse(value);
                                }
                                catch (_a) {
                                    return false;
                                }
                                return true;
                            };
                            reject(new TroError((isJson(event.message) ? (_a = JSON.parse(event.message)) === null || _a === void 0 ? void 0 : _a.message : event.message) || '', s_object_name, event));
                        }, { escape: false, buffer: false, timeout: 120000 });
                    }
                    catch (error) {
                        reject(new TroError(error.message, s_object_name, { criteria: criteria, clone_criteria: clone_criteria }));
                    }
                })];
        });
    });
};
export var fetchOne = function (s_object_name_1) {
    var args_1 = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args_1[_i - 1] = arguments[_i];
    }
    return __awaiter(void 0, __spreadArray([s_object_name_1], __read(args_1), false), void 0, function (s_object_name, criteria) {
        var result;
        if (criteria === void 0) { criteria = {}; }
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetchAll(s_object_name, deepmerge(criteria, { limit: 1 }))];
                case 1:
                    result = _a.sent();
                    return [2 /*return*/, result[0]];
            }
        });
    });
};
var _propsDateToUtc = function (props) {
    var clone_props = deepmerge({}, props);
    _getKeys(clone_props).forEach(function (_) {
        var p = clone_props[_];
        if (p instanceof Date) {
            clone_props[_] = addHours(p, -_time_zone_offset);
        }
    });
    return clone_props;
};
var _manipulateCallback = function (s_object_name, props, is_fetch, resolve, reject) {
    return function (error, ids) { return __awaiter(void 0, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (error != null) {
                        reject(new TroError(error.message, s_object_name, { props: props }));
                        return [2 /*return*/];
                    }
                    if (!is_fetch) {
                        resolve();
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, fetchOne(s_object_name, {
                            where: {
                                Id: { eq: ids[0] },
                            },
                        }).catch(function (_) { return _; })];
                case 1:
                    result = _a.sent();
                    if (result instanceof Error) {
                        reject(result);
                        return [2 /*return*/];
                    }
                    resolve(result);
                    return [2 /*return*/];
            }
        });
    }); };
};
export var ins = function (s_object_name, props, is_fetch) {
    if (is_fetch === void 0) { is_fetch = false; }
    return new Promise(function (resolve, reject) {
        try {
            _getRemoteObject(s_object_name).create(_propsDateToUtc(props), _manipulateCallback(s_object_name, props, is_fetch, resolve, reject));
        }
        catch (error) {
            reject(new TroError(error.message, s_object_name, { props: props }));
        }
    });
};
export var upd = function (s_object_name, id, props, is_fetch) {
    if (is_fetch === void 0) { is_fetch = false; }
    return new Promise(function (resolve, reject) {
        try {
            _getRemoteObject(s_object_name).update([id], _propsDateToUtc(props), _manipulateCallback(s_object_name, props, is_fetch, resolve, reject));
        }
        catch (error) {
            reject(new TroError(error.message, s_object_name, { props: props }));
        }
    });
};
export var del = function (s_object_name, id) {
    return new Promise(function (resolve, reject) {
        try {
            _getRemoteObject(s_object_name).del(id, function (error) {
                if (error == null) {
                    resolve();
                    return;
                }
                reject(new TroError(error.message, s_object_name, { id: id }));
            });
        }
        catch (error) {
            reject(new TroError(error.message, s_object_name, { id: id }));
        }
    });
};
export var criteria = function (_) {
    if (_ === void 0) { _ = {}; }
    return _;
};
export var props = function (_) { return _; };
//# sourceMappingURL=index.js.map