import { CustomError } from 'ts-custom-error';
import { Criteria, Props, Where } from './s-object-model';
export { Where };
export type Record<SObjectName, SObjectType> = {
    type: SObjectName;
    Id: string;
} & {
    [Field in keyof Props<SObjectType>]: NonNullable<Props<SObjectType>[Field]>;
};
export declare class TroError extends CustomError {
    message: string;
    s_object_name: string;
    attributes: object;
    constructor(message: string, s_object_name: string, attributes: object);
    toObject(): {
        name: string;
        message: string;
        s_object_name: string;
        attributes: object;
    };
}
export declare const init: (remoting_path: string, un_accessible_fields: {
    [s_object_name: string]: string[];
}, time_zone_offset?: number) => void;
export declare const fetchAll: <SObjectName extends string, SObjectType>(s_object_name: SObjectName, criteria?: Criteria<SObjectType> | undefined) => Promise<Record<SObjectName, SObjectType>[]>;
export declare const fetchOne: <SObjectName extends string, SObjectType>(s_object_name: SObjectName, criteria?: Omit<Criteria<SObjectType>, "limit"> | undefined) => Promise<Record<SObjectName, SObjectType> | undefined>;
export declare const ins: <SObjectName extends string, SObjectType, Fetch extends true | false = false>(s_object_name: SObjectName, props: Props<SObjectType>, is_fetch?: Fetch) => Promise<Fetch extends true ? Record<SObjectName, SObjectType> : void>;
export declare const upd: <SObjectName extends string, SObjectType, Fetch extends true | false = false>(s_object_name: SObjectName, id: string, props: Props<SObjectType>, is_fetch?: Fetch) => Promise<Fetch extends true ? Record<SObjectName, SObjectType> : void>;
export declare const del: (s_object_name: string, id: string) => Promise<void>;
export declare const criteria: <SObjectType>(_?: Criteria<SObjectType>) => Criteria<SObjectType>;
export declare const props: <SObjectType>(_: Props<SObjectType>) => Props<SObjectType>;
//# sourceMappingURL=index.d.ts.map